# Documentation
Documentation is available on several topics:
* Theory:
  + The notion of extensibility Extensibella uses in reasoning about
    extensible languages:
    [extensible_languages.md](extensible_languages.md)
  + The method of proving properties modularly:
    [modular_reasoning.md](modular_reasoning.md)
* The Extensibella language:
  + The module system as used in Extensibella:
    [modules.md](modules.md)
  + The syntax and commands in the Extensibella language:
    [reference.md](reference.md)
  + The way extensibility interacts with proving properties in
    Extensibella:  [extensibility.md](extensibility.md)
* How to run Extensibella for writing, checking, and compiling files:
  [running.md](running.md)
* The Extensibella standard library:  [stdLib.md](stdLib.md)
* Internal details about how Extensibella works:
  + The various files Extensibella associates with each module:
    [files.md](files.md)
  + The expectations of language encodings so Extensibella can read
    them to reason about them correctly:
    [encoding_format.md](encoding_format.md)
  + How Extensibella communicates with Abella:
    [abella_communication.md](abella_communication.md)
